"""autogenerated by genmsg_py from CounterbalanceTestData.msg. Do not edit."""
import roslib.message
import struct

import joint_qualification_controllers.msg

class CounterbalanceTestData(roslib.message.Message):
  _md5sum = "ab80d40971aa9176fd2c9fb75aeb93cf"
  _type = "joint_qualification_controllers/CounterbalanceTestData"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """string lift_joint
string flex_joint
float32 lift_amplitude
float32 flex_amplitude
bool timeout_hit
bool flex_test
string[] arg_name
float32[] arg_value
CBRunData[] lift_data # Data for each hold
================================================================================
MSG: joint_qualification_controllers/CBRunData
float32 lift_position
CBPositionData[] flex_data # Same lift position, diff flex positions
================================================================================
MSG: joint_qualification_controllers/CBPositionData
float32 flex_position
JointPositionData lift_hold
JointPositionData flex_hold

================================================================================
MSG: joint_qualification_controllers/JointPositionData
float32[] time
float32[] position
float32[] velocity
float32[] effort
"""
  __slots__ = ['lift_joint','flex_joint','lift_amplitude','flex_amplitude','timeout_hit','flex_test','arg_name','arg_value','lift_data']
  _slot_types = ['string','string','float32','float32','bool','bool','string[]','float32[]','joint_qualification_controllers/CBRunData[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       lift_joint,flex_joint,lift_amplitude,flex_amplitude,timeout_hit,flex_test,arg_name,arg_value,lift_data
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(CounterbalanceTestData, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.lift_joint is None:
        self.lift_joint = ''
      if self.flex_joint is None:
        self.flex_joint = ''
      if self.lift_amplitude is None:
        self.lift_amplitude = 0.
      if self.flex_amplitude is None:
        self.flex_amplitude = 0.
      if self.timeout_hit is None:
        self.timeout_hit = False
      if self.flex_test is None:
        self.flex_test = False
      if self.arg_name is None:
        self.arg_name = []
      if self.arg_value is None:
        self.arg_value = []
      if self.lift_data is None:
        self.lift_data = []
    else:
      self.lift_joint = ''
      self.flex_joint = ''
      self.lift_amplitude = 0.
      self.flex_amplitude = 0.
      self.timeout_hit = False
      self.flex_test = False
      self.arg_name = []
      self.arg_value = []
      self.lift_data = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self.lift_joint
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.flex_joint
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2f2B.pack(_x.lift_amplitude, _x.flex_amplitude, _x.timeout_hit, _x.flex_test))
      length = len(self.arg_name)
      buff.write(_struct_I.pack(length))
      for val1 in self.arg_name:
        length = len(val1)
        buff.write(struct.pack('<I%ss'%length, length, val1))
      length = len(self.arg_value)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.pack(pattern, *self.arg_value))
      length = len(self.lift_data)
      buff.write(_struct_I.pack(length))
      for val1 in self.lift_data:
        buff.write(_struct_f.pack(val1.lift_position))
        length = len(val1.flex_data)
        buff.write(_struct_I.pack(length))
        for val2 in val1.flex_data:
          buff.write(_struct_f.pack(val2.flex_position))
          _v1 = val2.lift_hold
          length = len(_v1.time)
          buff.write(_struct_I.pack(length))
          pattern = '<%sf'%length
          buff.write(struct.pack(pattern, *_v1.time))
          length = len(_v1.position)
          buff.write(_struct_I.pack(length))
          pattern = '<%sf'%length
          buff.write(struct.pack(pattern, *_v1.position))
          length = len(_v1.velocity)
          buff.write(_struct_I.pack(length))
          pattern = '<%sf'%length
          buff.write(struct.pack(pattern, *_v1.velocity))
          length = len(_v1.effort)
          buff.write(_struct_I.pack(length))
          pattern = '<%sf'%length
          buff.write(struct.pack(pattern, *_v1.effort))
          _v2 = val2.flex_hold
          length = len(_v2.time)
          buff.write(_struct_I.pack(length))
          pattern = '<%sf'%length
          buff.write(struct.pack(pattern, *_v2.time))
          length = len(_v2.position)
          buff.write(_struct_I.pack(length))
          pattern = '<%sf'%length
          buff.write(struct.pack(pattern, *_v2.position))
          length = len(_v2.velocity)
          buff.write(_struct_I.pack(length))
          pattern = '<%sf'%length
          buff.write(struct.pack(pattern, *_v2.velocity))
          length = len(_v2.effort)
          buff.write(_struct_I.pack(length))
          pattern = '<%sf'%length
          buff.write(struct.pack(pattern, *_v2.effort))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.lift_joint = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.flex_joint = str[start:end]
      _x = self
      start = end
      end += 10
      (_x.lift_amplitude, _x.flex_amplitude, _x.timeout_hit, _x.flex_test,) = _struct_2f2B.unpack(str[start:end])
      self.timeout_hit = bool(self.timeout_hit)
      self.flex_test = bool(self.flex_test)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.arg_name = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1 = str[start:end]
        self.arg_name.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.arg_value = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.lift_data = []
      for i in range(0, length):
        val1 = joint_qualification_controllers.msg.CBRunData()
        start = end
        end += 4
        (val1.lift_position,) = _struct_f.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.flex_data = []
        for i in range(0, length):
          val2 = joint_qualification_controllers.msg.CBPositionData()
          start = end
          end += 4
          (val2.flex_position,) = _struct_f.unpack(str[start:end])
          _v3 = val2.lift_hold
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sf'%length
          start = end
          end += struct.calcsize(pattern)
          _v3.time = struct.unpack(pattern, str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sf'%length
          start = end
          end += struct.calcsize(pattern)
          _v3.position = struct.unpack(pattern, str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sf'%length
          start = end
          end += struct.calcsize(pattern)
          _v3.velocity = struct.unpack(pattern, str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sf'%length
          start = end
          end += struct.calcsize(pattern)
          _v3.effort = struct.unpack(pattern, str[start:end])
          _v4 = val2.flex_hold
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sf'%length
          start = end
          end += struct.calcsize(pattern)
          _v4.time = struct.unpack(pattern, str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sf'%length
          start = end
          end += struct.calcsize(pattern)
          _v4.position = struct.unpack(pattern, str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sf'%length
          start = end
          end += struct.calcsize(pattern)
          _v4.velocity = struct.unpack(pattern, str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sf'%length
          start = end
          end += struct.calcsize(pattern)
          _v4.effort = struct.unpack(pattern, str[start:end])
          val1.flex_data.append(val2)
        self.lift_data.append(val1)
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self.lift_joint
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.flex_joint
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2f2B.pack(_x.lift_amplitude, _x.flex_amplitude, _x.timeout_hit, _x.flex_test))
      length = len(self.arg_name)
      buff.write(_struct_I.pack(length))
      for val1 in self.arg_name:
        length = len(val1)
        buff.write(struct.pack('<I%ss'%length, length, val1))
      length = len(self.arg_value)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.arg_value.tostring())
      length = len(self.lift_data)
      buff.write(_struct_I.pack(length))
      for val1 in self.lift_data:
        buff.write(_struct_f.pack(val1.lift_position))
        length = len(val1.flex_data)
        buff.write(_struct_I.pack(length))
        for val2 in val1.flex_data:
          buff.write(_struct_f.pack(val2.flex_position))
          _v5 = val2.lift_hold
          length = len(_v5.time)
          buff.write(_struct_I.pack(length))
          pattern = '<%sf'%length
          buff.write(_v5.time.tostring())
          length = len(_v5.position)
          buff.write(_struct_I.pack(length))
          pattern = '<%sf'%length
          buff.write(_v5.position.tostring())
          length = len(_v5.velocity)
          buff.write(_struct_I.pack(length))
          pattern = '<%sf'%length
          buff.write(_v5.velocity.tostring())
          length = len(_v5.effort)
          buff.write(_struct_I.pack(length))
          pattern = '<%sf'%length
          buff.write(_v5.effort.tostring())
          _v6 = val2.flex_hold
          length = len(_v6.time)
          buff.write(_struct_I.pack(length))
          pattern = '<%sf'%length
          buff.write(_v6.time.tostring())
          length = len(_v6.position)
          buff.write(_struct_I.pack(length))
          pattern = '<%sf'%length
          buff.write(_v6.position.tostring())
          length = len(_v6.velocity)
          buff.write(_struct_I.pack(length))
          pattern = '<%sf'%length
          buff.write(_v6.velocity.tostring())
          length = len(_v6.effort)
          buff.write(_struct_I.pack(length))
          pattern = '<%sf'%length
          buff.write(_v6.effort.tostring())
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.lift_joint = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.flex_joint = str[start:end]
      _x = self
      start = end
      end += 10
      (_x.lift_amplitude, _x.flex_amplitude, _x.timeout_hit, _x.flex_test,) = _struct_2f2B.unpack(str[start:end])
      self.timeout_hit = bool(self.timeout_hit)
      self.flex_test = bool(self.flex_test)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.arg_name = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1 = str[start:end]
        self.arg_name.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.arg_value = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.lift_data = []
      for i in range(0, length):
        val1 = joint_qualification_controllers.msg.CBRunData()
        start = end
        end += 4
        (val1.lift_position,) = _struct_f.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.flex_data = []
        for i in range(0, length):
          val2 = joint_qualification_controllers.msg.CBPositionData()
          start = end
          end += 4
          (val2.flex_position,) = _struct_f.unpack(str[start:end])
          _v7 = val2.lift_hold
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sf'%length
          start = end
          end += struct.calcsize(pattern)
          _v7.time = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sf'%length
          start = end
          end += struct.calcsize(pattern)
          _v7.position = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sf'%length
          start = end
          end += struct.calcsize(pattern)
          _v7.velocity = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sf'%length
          start = end
          end += struct.calcsize(pattern)
          _v7.effort = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
          _v8 = val2.flex_hold
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sf'%length
          start = end
          end += struct.calcsize(pattern)
          _v8.time = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sf'%length
          start = end
          end += struct.calcsize(pattern)
          _v8.position = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sf'%length
          start = end
          end += struct.calcsize(pattern)
          _v8.velocity = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sf'%length
          start = end
          end += struct.calcsize(pattern)
          _v8.effort = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
          val1.flex_data.append(val2)
        self.lift_data.append(val1)
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_2f2B = struct.Struct("<2f2B")
_struct_f = struct.Struct("<f")
